#ifndef __GSNETCLIENT_H__
#define __GSNETCLIENT_H__

#include "GSNetStructDef.h"

//#define __BUILD_LIB

#if defined __BUILD_DLL
	#define GSNET_DLLAPI		extern "C" __declspec(dllexport)
#elif defined __BUILD_LIB
	#define GSNET_DLLAPI
#else
	#define GSNET_DLLAPI		extern "C" __declspec(dllimport)
#endif


/***************************̨******************************/
#define PTZ_STOP		0	/*	ֹ̨ͣ*/

#define TILT_UP		1	/* ̨Speedٶת */
#define TILT_DOWN		2	/* ̨Speedٶת */
#define PAN_LEFT		3	/* ̨Speedٶת */
#define PAN_RIGHT		4	/* ̨Speedٶת */


#define PT_LEFT_UP	5	/* ̨Speedٶ */
#define PT_LEFT_DOWN	6	/* ̨Speedٶ */
#define PT_RIGHT_UP	7	/* ̨Speedٶ */
#define PT_RIGHT_DOWN	8	/* ̨Speedٶ */

#define PTZ_ZOOM_IN		9 	/* ٶSpeed(ʱ) */
#define PTZ_ZOOM_OUT		10	/* ٶSpeedС(ʱС) */
#define FOCUS_NEAR	11	/* ٶSpeedǰ */
#define FOCUS_FAR		12	/* ٶSpeed */
#define IRIS_OPEN		13	/* ȦٶSpeed */
#define IRIS_CLOSE	14	/* ȦٶSpeedС */


#define GOTO_PRESET	15	/* תԤõ */
#define CLE_PRESET	16	/* Ԥõ */
#define SET_PRESET	17	/* Ԥõ */


#define PAN_AUTO		18	/* ̨SpeedٶѲ */
#define PAN_AUTO_STOP	19	/* Ѳֹͣ */

//extern "C"
//{
/******************************************************************/
//ʼ
GSNET_DLLAPI BOOL __stdcall GSNET_Startup(UINT ulMessage, HWND hWnd, void (WINAPI *messagecallback)(LONG handle, int wParam, int lParam, void *context)=NULL, void* context=NULL);
GSNET_DLLAPI VOID __stdcall GSNET_Cleanup();
GSNET_DLLAPI BOOL __stdcall GSNET_SetWaitTime(int WaitTime=5, int TryNum=3, int TryInterval=10);
GSNET_DLLAPI VOID __stdcall GSNET_Log(const char *strFormat, ...);

//ʵʱԤ
GSNET_DLLAPI LONG __stdcall GSNET_ClientStart(CHANNEL_CLIENTINFO *pChaninfo);
GSNET_DLLAPI BOOL __stdcall GSNET_ClientStop(LONG hHandle);
GSNET_DLLAPI BOOL __stdcall GSNET_ClientStartView(LONG hHandle);
GSNET_DLLAPI BOOL __stdcall GSNET_ClientStopView(LONG hHandle);
GSNET_DLLAPI BOOL __stdcall GSNET_ClientSetWnd(LONG hHandle, HWND hWnd);
GSNET_DLLAPI BOOL __stdcall GSNET_ClientRefreshWnd(LONG hHandle);
GSNET_DLLAPI BOOL __stdcall GSNET_ClientShowcallback(LONG hHandle, void(WINAPI *ShowCallBack)(BYTE *m_y, BYTE *m_u, BYTE *m_v, int stridey, int strideuv, int width, int height, void *context), void *context);
GSNET_DLLAPI LONG __stdcall GSNET_GetClientState(LONG hHandle);
GSNET_DLLAPI BOOL __stdcall GSNET_GetBitStreamInfo(LONG hHandle, ULONG *pBitRate, ULONG *pFrameRate);
GSNET_DLLAPI BOOL __stdcall GSNET_ClientSetVideoParam(LONG hHandle, BYTE cbBrightness, BYTE cbContrast, BYTE cbSaturation, ULONG bDefault = 0);
GSNET_DLLAPI BOOL __stdcall GSNET_ClientGetVideoParam(LONG hHandle, BYTE *pcbBrightness, BYTE *pcbContrast, BYTE *pcbSaturation);
GSNET_DLLAPI void __stdcall GSNET_ClientVerticalFlip(LONG hHandle, BOOL bVFlip);

//GSNET_DLLAPI void __stdcall GSNET_ClientFlip(LONG hHandle, BOOL bHorizontal, BOOL bVertical);
GSNET_DLLAPI void __stdcall GSNET_ClientRotate180(LONG hHandle, BOOL bRotate180);

//
GSNET_DLLAPI BOOL __stdcall GSNET_ClientPlayAudio(LONG hHandle);
GSNET_DLLAPI BOOL __stdcall GSNET_ClientStopAudio(LONG hHandle);

//ץͼ
GSNET_DLLAPI BOOL __stdcall GSNET_ClientCapturePicture(LONG hHandle, const char* filename);

//¼
GSNET_DLLAPI BOOL __stdcall GSNET_ClientStartRecord(LONG hHandle, const char* filename, DWORD dwDurationSeconds=0);
GSNET_DLLAPI BOOL __stdcall GSNET_ClientStopRecord(LONG hHandle);
GSNET_DLLAPI BOOL __stdcall GSNET_ClientStartAlarmRecord(LONG hHandle, const char* filename, DWORD dwDurationSeconds=0);
GSNET_DLLAPI BOOL __stdcall GSNET_ClientStopAlarmRecord(LONG hHandle);

//澯
GSNET_DLLAPI BOOL __stdcall GSNET_ClientStartAlarmOut(LONG hHandle,
													  const char *host, 
													  long port,
													  long channel,
													  const char* user,
													  const char* psw,
													  BOOL bTrans = FALSE);

GSNET_DLLAPI BOOL __stdcall GSNET_ClientStopAlarmOut(LONG hHandle,
													 const char *host, 
													 long port,
													 long channel,
													 const char* user,
													 const char* psw,
													 BOOL bTrans = FALSE);

//̨
GSNET_DLLAPI BOOL __stdcall GSNET_ClientPTZCtrl(LONG hHandle, int type, int param);

//ƶ
GSNET_DLLAPI BOOL __stdcall GSNET_ClientGetMDInfo(LONG hHandle, MOTION_DETECT_INFO* pMDInfo/*out*/);
GSNET_DLLAPI BOOL __stdcall GSNET_ClientSaveMDInfo(LONG hHandle, MOTION_DETECT_INFO* pMDInfo/*in*/);
GSNET_DLLAPI BOOL __stdcall GSNET_ClientStartMD(LONG hHandle);
GSNET_DLLAPI BOOL __stdcall GSNET_ClientStopMD(LONG hHandle);
GSNET_DLLAPI BOOL __stdcall GSNET_ClientStopAlarm(LONG hHandle, ULONG ulDeviceNum);
//ulShow = 0x01ʾƶ, ulShow = 0x02ʾ(Ĭ),ֵȡһ
GSNET_DLLAPI BOOL __stdcall GSNET_ClientShowMDRegion(LONG hHandle, ULONG ulShow);

//˫
GSNET_DLLAPI BOOL __stdcall GSNET_ClientStartTalk(LONG hHandle);
GSNET_DLLAPI void __stdcall GSNET_ClientStopTalk(LONG hHandle);

//ļطź
GSNET_DLLAPI LONG __stdcall  GSNET_OpenFile(const char* filename, HWND hWnd, BOOL bPause=FALSE);
GSNET_DLLAPI BOOL __stdcall  GSNET_CloseFile(LONG hHandle);
GSNET_DLLAPI BOOL __stdcall  GSNET_ReplayPause(LONG hHandle);
GSNET_DLLAPI BOOL __stdcall  GSNET_ReplayContinue(LONG hHandle);
GSNET_DLLAPI BOOL __stdcall  GSNET_ReplayStepByStep(LONG hHandle);
GSNET_DLLAPI BOOL __stdcall  GSNET_SpeedFast(LONG hHandle);
GSNET_DLLAPI BOOL __stdcall  GSNET_SpeedNormal(LONG hHandle);
GSNET_DLLAPI BOOL __stdcall  GSNET_SpeedSlow(LONG hHandle);
GSNET_DLLAPI ULONG __stdcall GSNET_ReplayTotalTime(LONG hHandle);
GSNET_DLLAPI ULONG __stdcall GSNET_ReplayCurTime(LONG hHandle);
GSNET_DLLAPI BOOL  __stdcall GSNET_ReplaySeek(LONG hHandle, ULONG ulSeconds);

// ȡƵʵʱļŶԵô˲
GSNET_DLLAPI BOOL __stdcall  GSNET_GetClientParam(LONG hHandle, STREAM_PARAM* pClientParam);


//Ƶݻص,ʱЧڲʵִ뱻
GSNET_DLLAPI void __stdcall  GSNET_SetAVCallback( LONG ( WINAPI* callback )
															( LONG hHandle, \
															const BYTE * pBuf, \
															LONG  nSize, \
															const FRAME_INFO * pFrameInfo, \
															LPVOID lpContext ) );

//ƵʾDCص
GSNET_DLLAPI void __stdcall  GSNET_SetDrawCallback(long ( WINAPI* DrawCallback )( LONG hHandle, HDC hDC, void* lpContext ));

//ôֱˢͬ param 0 Ϊͬ 1Ϊȫͬ
GSNET_DLLAPI void __stdcall  GSNET_SetVertBlank(LONG hHandle, UINT param );

//Ƶл֡
GSNET_DLLAPI void __stdcall  GSNET_SetRestoreFrame(LONG hHandle, UINT frame );

GSNET_DLLAPI void __stdcall  GSNET_SetLiveViewPerformance(LONG hHandle,int nPerformance);

//תרָ,ѯĿ豸תеͨ(ID),ID
GSNET_DLLAPI long __stdcall  GSNET_QueryServerChannel(const char*serverhost, 
													  long serverport,
													const char* srchost, 
												   long rtspPort, 
												   long channel, 
												   const char* user,
												   const char* psw);

GSNET_DLLAPI LONG __stdcall GSNET_ClientGetServerChannels(const char *serverhost,
														  long serverport,
														  const char* user,
														  const char* psw,
														  SERVER_CHANNEL_PACKET *pServerChannelPacket);

GSNET_DLLAPI LONG __stdcall GSNET_ClientUpdateServerChannel(const char *serverhost,
														  long serverport,
														  const char* user,
														  const char* psw,
														 UPDATE_C2S_CHANNEL_PACKET *pUpdate_C2S_Ch_Pack,
														  UPDATE_SERVER_CHANNEL_PACKET *pServerUpdateChannelPacket);

//ʹתƵ,ʵǱGSNET_ClientStart һGSNET_QueryServerChannelĵ
GSNET_DLLAPI LONG __stdcall GSNET_ClientStart_Trans(CHANNEL_CLIENTINFO *pChaninfo, long srcchannel, long useTrans);


//ʹɫǿģʽ
GSNET_DLLAPI void __stdcall  GSNET_VideoEnhanceMode(LONG hHandle, BOOL bUse );





#endif


