#ifndef __GSNETSTRUCTDEF_H__
#define __GSNETSTRUCTDEF_H__

#define MAX_SERVER_NAME_LEN			32
#define MAX_USER_NAME_LEN			32
#define MAX_PASSWORD_LEN			64
#define MAX_FILENAME_LEN			255
#define MAX_SERVER_CHANNEL_COUNT    200
#define MAX_DEV_NAME			    128
#define MAX_DOMAIN_NAME             128

enum{
	PROTOCOL_RTSP_UDP   = 0,
	PROTOCOL_RTSP_TCP   = 1,
	PROTOCOL_UDP		=2,
};

typedef struct{
	WORD  m_protocol;				 //Э
	WORD  m_playstart;               //ǷԤ
	unsigned long m_ch;              //ͨ 
	HWND  m_hVideohWnd;              //Ƶھ
	HWND  m_hChMsgWnd;               //ϢھֻϢصŲô˲
	UINT  m_nChMsgID;                //ͨϢID
	BYTE  tryRGBfirst;				 //Ƶʾʱ,ȳʹRGB;
	BYTE  model;					//豸ͺ      
	BYTE  res1;
	BYTE  res2;
	int   m_nPerformence;            //
	int   m_useoverlay;              //Ƿʹoverlay()
	COLORREF nColorKey;                 //color key()
	void  *lpreserved;

	void  *context;			//ص,ϢصƵصƵʾDCصص˲

	char url[128];				    //ӵurl  : 192.168.83.254:554
	char m_sername[MAX_SERVER_NAME_LEN+1];  //
	char m_username[MAX_USER_NAME_LEN+1];   //û
	char m_password[MAX_PASSWORD_LEN+1];    //
}CHANNEL_CLIENTINFO;


typedef struct _tagSERVER_CHANNEL
{
	char    cState;
	char	szDevName[MAX_DEV_NAME];	    //豸
	char    szHostName[MAX_DOMAIN_NAME];
	char	cDevChannelNumber;			    //ͨ
	UINT    nChannelID;
	_tagSERVER_CHANNEL()
	{
		memset(szDevName,0,MAX_DEV_NAME);
		memset(szHostName,0,MAX_DOMAIN_NAME);
		cDevChannelNumber = 0;	
		nChannelID        = 1000;
		cState            = 0;
	}
}SERVER_CHANNEL;//豸ݵļ

typedef struct
{
	char cResult;
	int cChannelCount;
	SERVER_CHANNEL ServerChanel[MAX_SERVER_CHANNEL_COUNT];
}SERVER_CHANNEL_PACKET;

enum Server_Opertion_State{CHANNEL_NONE,CHANNEL_ADD,CHANNEL_DELETE};

typedef struct _tagUPDATE_SERVER_CHANNEL
{
	Server_Opertion_State  cUpdateFlag;
	SERVER_CHANNEL         ServerChanel;
}UPDATE_SERVER_CHANNEL;//豸ݵļ

typedef struct
{
	char cResult;
	int cChannelCount;
	UPDATE_SERVER_CHANNEL UpdateServerChanel[MAX_SERVER_CHANNEL_COUNT];
}UPDATE_SERVER_CHANNEL_PACKET;

typedef struct
{
	int nCount;
	int channel[MAX_SERVER_CHANNEL_COUNT];
}UPDATE_C2S_CHANNEL_PACKET;

typedef struct 
{
	unsigned short nWidth;	 // λΪأƵΪ0
	unsigned short nHeight;	 // ߣλΪأƵΪ0
	long nStamp;			// ʱϢλ
	unsigned short avType;	 //ͣ0 Ƶ 1 Ƶ
	unsigned short videoCoder;//Ƶ뷽ʽ
	unsigned short audioCoder;//Ƶ뷽ʽ
	unsigned short frameRate;  // Ƶͼ֡
	unsigned short nalType;    // H264֡ 涨

	unsigned short packageType;//ݰ 01ʼ2м3

	unsigned short reserved1;
	unsigned short reserved2;
}FRAME_INFO;



//FRAME_INFO.avType
#define AVTYPE_VIDEO	0
#define AVTYPE_AUDIO	1

//FRAME_INFO.packageType
#define PACKAGE_SINGLE		0
#define PACKAGE_START		1
#define PACKAGE_MID			2
#define PACKAGE_END			3

//FRAME_INFO.nalType
#define NAL_TYPE_SLICE      1
#define NAL_TYPE_IDR        5
#define NAL_TYPE_SEI        6
#define NAL_TYPE_SPS        7
#define NAL_TYPE_PPS        8
#define NAL_TYPE_SEQ_END    9
#define NAL_TYPE_STREAM_END 10

//FRAME_INFO.videoCoder
#ifndef VIDEO_CODER_H264
#define VIDEO_CODER_H264				96
#define VIDEO_CODER_MJPEG				26
#define VIDEO_CODER_MPEG4				99
#endif

//FRAME_INFO.audioCoder
#define AUDIO_CODER_G711_A				0x01  /* 64kbps G.711 A, see RFC3551.txt  4.5.14 PCMA */
#define AUDIO_CODER_G711_U				0x02  /* 64kbps G.711 U, see RFC3551.txt  4.5.14 PCMU */
#define AUDIO_CODER_G726_16KBPS			0x04  /* 16kbps G.726, see RFC3551.txt  4.5.4 G726-16 */
#define AUDIO_CODER__G726_24KBPS		0x05  /* 24kbps G.726, see RFC3551.txt  4.5.4 G726-24 */
#define AUDIO_CODER_G726_32KBPS			0x06  /* 32kbps G.726, see RFC3551.txt  4.5.4 G726-32 */
#define AUDIO_CODER_G726_40KBPS			0x07  /* 40kbps G.726, see RFC3551.txt  4.5.4 G726-40 */


/******ƶ*****/
#define MAX_MOTION_REGION		16
typedef struct
{
	BYTE	cbSensitive[MAX_MOTION_REGION];
	RECT	rcRegion[MAX_MOTION_REGION];
}MOTION_DETECT_INFO;
/***************/

typedef struct
{
	unsigned short	videoWidth;
	unsigned short	videoHeight;
	unsigned short	frameRate;
	BYTE			videoCoder;
	BYTE			audioCoder;
		
	unsigned long	bitRate;

	unsigned long	reserved1;
	unsigned long	reserved2;
	unsigned long	reserved3;
	unsigned long	reserved4;

}STREAM_PARAM;

/*************************** Ϣ ********************************/
/*wParam*/
#define GSMSG_LINKMSG					1			//ӷϢ
/*lParam*/
#define GSMSG_LINKMSG_OK				0			//ɹ
#define GSMSG_LINKMSG_CONNECTING		1			//(м״̬)ͨ
#define GSMSG_LINKMSG_FAILED			2			//ʧ
#define GSMSG_LINKMSG_DISCONNECT		3			//Ͽ
#define GSMSG_LINKMSG_RECONNECT			4			//
#define GSMSG_LINKMSG_PLAYFAILED		5			//ʧ,

/**new  add*/
#define GSMSG_LINKMSG_UNAUTHORIZED		6			//û
#define GSMSG_LINKMSG_SERVER_GETID_FAILED 7			//ȡת豸ʱʧ
#define GSMSG_LINKMSG_SERVER_NOTFIND_DEST   8		//תӳɹ,Ҳת豸


/*wParam*/
#define GSMSG_VIDEOMOTION		2		//Ƶƶ
#define GSMSG_VIDEOLOST			3 		//Ƶʧ
#define GSMSG_ALARM				4		//̽ͷ
#define GSMSG_OUTPUTSTATUS		5		//״̬

/*wParam*/
#define GSMSG_RECORD			6		//¼״̬

/*lParam*/
#define GSMSG_RECORD_BEGIN_NORMAL_RECORD		0
#define GSMSG_RECORD_END_NORMAL_RECORD			1		
#define GSMSG_RECORD_BEGIN_ALARM_RECORD			2
#define GSMSG_RECORD_END_ALARM_RECORD			3
#define GSMSG_RECORD_NORMAL_PACKET_FINISH		4//¼
#define GSMSG_RECORD_ALARM_PACKET_FINISH		5

/*wparam*/
#define GSMSG_REPLAY_END		7		//ط¼

#endif




